function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { createContext, useRef, useState } from 'react';
import useEngineContext from "../../../hooks/useEngineContext";
var defaultData = {};
var SALES_MODEL_SESSION_STORAGE_KEY = 'shop_h5_sales_model_data';
export var SalesContext = /*#__PURE__*/createContext({});
export var SalesProvider = function SalesProvider(props) {
  var children = props.children,
    config = props.config;
  var dataRef = useRef({});
  var _useState = useState(defaultData),
    _useState2 = _slicedToArray(_useState, 2),
    data = _useState2[0],
    setData = _useState2[1];
  var _useState3 = useState(props.hooks),
    _useState4 = _slicedToArray(_useState3, 2),
    hooks = _useState4[0],
    setHooks = _useState4[1];
  var context = useEngineContext();
  var utils = context.appHelper.utils || {};
  var _setData = function _setData(newData) {
    dataRef.current = _objectSpread(_objectSpread({}, dataRef.current), newData);
    console.log('sales_model_newData', dataRef.current);
    if (config !== null && config !== void 0 && config.useSessionStorage) {
      setSessionStorage();
    }
    setData(_objectSpread({}, dataRef.current));
  };
  var getCurrentData = function getCurrentData() {
    return dataRef.current;
  };

  /**
   * @title 设置sessionStorage
   * @description 获取路由参数中的cacheId，并设置到sessionStorage中
   */
  var setSessionStorage = function setSessionStorage() {
    var _utils$getHistory, _history$location;
    var history = (utils === null || utils === void 0 || (_utils$getHistory = utils.getHistory) === null || _utils$getHistory === void 0 ? void 0 : _utils$getHistory.call(utils)) || {};
    var cacheId = (history === null || history === void 0 || (_history$location = history.location) === null || _history$location === void 0 || (_history$location = _history$location.query) === null || _history$location === void 0 ? void 0 : _history$location.cacheId) || '';
    var sessionData = _objectSpread(_objectSpread({}, dataRef.current || {}), {}, {
      cacheId: cacheId
    });
    sessionStorage.setItem("".concat(SALES_MODEL_SESSION_STORAGE_KEY), JSON.stringify(sessionData || {}));
  };

  /**
   * @title 获取sessionStorage
   * @description 获取路由参数中的cacheId并与sessionStorage中的cacheId进行匹配，如果匹配成功，则返回sessionStorage中的数据
   */
  var getSessionStorage = function getSessionStorage() {
    var _utils$getHistory2, _history$location2;
    var history = (utils === null || utils === void 0 || (_utils$getHistory2 = utils.getHistory) === null || _utils$getHistory2 === void 0 ? void 0 : _utils$getHistory2.call(utils)) || {};
    var strResult = sessionStorage.getItem(SALES_MODEL_SESSION_STORAGE_KEY);
    var result = strResult ? JSON.parse(strResult || '{}') : {};
    var cacheId = (history === null || history === void 0 || (_history$location2 = history.location) === null || _history$location2 === void 0 || (_history$location2 = _history$location2.query) === null || _history$location2 === void 0 ? void 0 : _history$location2.cacheId) || '';

    // cacheId 为空，且sessionStorage中cacheId也为空，则返回sessionStorage中的数据
    if (!cacheId && !(result !== null && result !== void 0 && result.cacheId)) {
      return result;
    }

    // cacheId 不为空，需要比对sessionStorage中的cacheId与路由参数中的cacheId是否一致
    if (cacheId && (result === null || result === void 0 ? void 0 : result.cacheId) === cacheId) {
      return result;
    }
    return {};
  };
  var removeSessionStorage = function removeSessionStorage() {
    sessionStorage.removeItem(SALES_MODEL_SESSION_STORAGE_KEY);
  };
  return /*#__PURE__*/React.createElement(SalesContext.Provider, {
    value: {
      data: data,
      setData: _setData,
      getCurrentData: getCurrentData,
      hooks: hooks,
      setHooks: setHooks,
      setSessionStorage: setSessionStorage,
      getSessionStorage: getSessionStorage,
      removeSessionStorage: removeSessionStorage
    }
  }, children);
};
export var useSales = function useSales() {
  var context = React.useContext(SalesContext);
  if (!context) {
    throw new Error('useSales must be used within a SalesProvider');
  }
  return context;
};